#!/usr/bin/env bash

# HugePages tunning
function HugePagesTune(){
   if [[ ! -z $XMRIG_NEW_HUGEPAGES ]]; then
       echo "Start HugePages tuning for RandomX ..."
       hugepages $XMRIG_NEW_HUGEPAGES
   else
      if [[ `echo $XMRIG_NEW_ALGO | grep -c "^rx\/"` -gt 0 ]]; then
          echo "Start HugePages tuning for RandomX ..."
          is_1gb=$(cat $MINER_DIR/$MINER_FORK/$MINER_VER/config.json | jq '."randomx"."1gb-pages"')
          sysctl -w vm.nr_hugepages=0 > /dev/null
          [[ $is_1gb == "true" ]] && hugepages -erx || hugepages -rx
      fi
   fi
}

[[ `ps aux | egrep './[x]mrig' | grep -v xmrig-amd | grep -v xmrig-nvidia | wc -l` != 0 ]] &&
	echo -e "${RED}$MINER_NAME miner is already running${NOCOLOR}" &&
	exit 1

HugePagesTune

# Miner run here
cd $MINER_DIR/$MINER_FORK/$MINER_VER
[[ -e $MINER_DIR/$MINER_FORK/$MINER_VER/libxmrig-cuda.so.xz ]] && (echo -n "Decompressing ${CYAN}XMRig CUDA plugin${NOCOLOR} ... "; xz -d libxmrig-cuda.so.xz && echo "${GREEN}OK${NOCOLOR}")
./xmrig
